/*
 * DigitPR.java
 *
 * Created on October 2, 2004, 1:14 PM
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Rectangle2D;
import java.awt.image.Raster;
import java.awt.image.BufferedImage;
import java.awt.image.*;
import java.awt.color.ColorSpace;
import java.awt.image.ColorConvertOp;
import javax.imageio.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.*;
import javax.swing.plaf.basic.*;
import java.io.*;
import java.io.File;

/**
 *
 * @author  xiao
 */
public class DigitPR extends javax.swing.JFrame implements ChangeListener{
    
    final static int RED    = 0;
    final static int GREEN  = 1;
    final static int BLUE   = 2;
    final static int OFFSET = 3;  // ignore offset; use only red, green, blue
    // holds the kernels used with ConvolveOp
    final static float data[][] = {{0.1f, 0.1f, 0.1f,       // 3x3 blur
    0.1f, 0.2f, 0.1f,
    0.1f, 0.1f, 0.1f},
    {-1.0f, -1.0f, -1.0f,    // 3x3 sharpen
     -1.0f, 9.0f, -1.0f,
     -1.0f, -1.0f, -1.0f},
     {0.f, -1.f, 0.f,         // 3x3 edge
      -1.f, 5.f, -1.f,
      0.f, -1.f, 0.f},
      {1.0f, 2.0f, 1.0f,
       2.0f, 4.0f, 2.0f,
       1.0f, 2.0f, 1.0f},      // Gaussian blur
       {-1.0f, -1.0f, -1.0f, -1.0f, -1.0f,  //5x5 edge
        -1.0f, -1.0f, -1.0f, -1.0f, -1.0f,
        -1.0f, -1.0f, 24.0f, -1.0f, -1.0f,
        -1.0f, -1.0f, -1.0f, -1.0f, -1.0f,
        -1.0f, -1.0f, -1.0f, -1.0f, -1.0f}};
        
        /** Program Variables*/
        private GraphicsEnvironment ge;
        private Font [] fonts;
        private String [] regFonts =  {"Arial", "Arial Black", "Arial Narrow",
        "Bookman Old Style", "Century", "Courier", "Century Gothic",
        "Courier New", "Impact", "Serifa BT",  "SimHei", "SimSun",
        "Times", "Times New Roman", "Verdana"}; /** regular fonts*/
        private static String [] fontsizes = {"18", "24", "36", "48", "72", "100", "120", "200"};
        private static Image img;
        private JFrame disWindow;
        
        private static BufferedImage workImage = null;
        //private static BufferedImage scrImage = null;
        
        
        static StyledDocument doc;
        static MutableAttributeSet attr;
        static DigitExtraction extractor;
        private int[][][] testImage;
        private int[][] greyImage;
        private int[] boundArray;
        private int maxrows;
        private int maxcols;
        
        private File currentFile;
        private String currentPath = null;
        private int grey_threshold = 182; /* black and white image threshold*/
        private int random_total = 28; /* total number of digits to be generated*/
        private boolean font_crazy = false; /* use all avaible fonts or regular font set*/
        private boolean print_fea = false;  /* print out the digit image after feature extraction*/
        private boolean extracted = false;  /* status marking whether the feature extraction has been done*/
        
        /** Creates new form DigitPR */
        public DigitPR() {
            /** initial font type and size*/
            int res = JOptionPane.showConfirmDialog((Component)null, "Are you crazy about the fonts?",
            "Typing Digit Classifier", JOptionPane.YES_NO_OPTION);
            if (res == JOptionPane.YES_OPTION) {
                ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
                fonts = ge.getAllFonts();
                font_crazy = true;
            }
            else {
                fonts = new Font[regFonts.length];
                for (int i = 0; i < regFonts.length; i++) {
                    fonts[i] = new Font(regFonts[i], Font.PLAIN, 12);
                }
            }
            initComponents();
            ImageOpDisable();
            
            mnCreate.setEnabled(font_crazy);
        }
        
        /** This method is called from within the constructor to
         * initialize the form.
         */
        private void initComponents() {
            java.awt.GridBagConstraints gridBagConstraints;
            
            pnlImageSelection = new FileDisplayPanel();
            pnlImageDisplay = new javax.swing.JPanel();
            pnlButton = new javax.swing.JPanel();
            btnLoad = new javax.swing.JButton();
            btnDT = new javax.swing.JButton();
            btnNN = new javax.swing.JButton();
            btnTrain = new javax.swing.JButton();
            pnlFont = new javax.swing.JPanel();
            cbFontType = new javax.swing.JComboBox(fonts);
            cbFontSize = new javax.swing.JComboBox(fontsizes);
            btnAdd = new javax.swing.JButton();
            lblFontType = new javax.swing.JLabel();
            lblFontSize = new javax.swing.JLabel();
            pnlTextInput = new javax.swing.JPanel();
            txtaTextInput = new javax.swing.JTextPane();
            //pnlResult = new javax.swing.JScrollPane();
            txtfResult = new javax.swing.JTextArea();
            mbrPR = new javax.swing.JMenuBar();
            mnFile = new javax.swing.JMenu();
            mnCreate = new javax.swing.JMenu();
            mntExit = new javax.swing.JMenuItem();
            mnImage = new javax.swing.JMenu();
            mntZeros = new javax.swing.JMenuItem();
            mntOnes = new javax.swing.JMenuItem();
            mntTwos = new javax.swing.JMenuItem();
            mntThrees = new javax.swing.JMenuItem();
            mntFours = new javax.swing.JMenuItem();
            mntFives = new javax.swing.JMenuItem();
            mntSixs = new javax.swing.JMenuItem();
            mntSevens = new javax.swing.JMenuItem();
            mntEights = new javax.swing.JMenuItem();
            mntNines = new javax.swing.JMenuItem();
            mntBound = new javax.swing.JMenuItem();
            mntFeature = new javax.swing.JMenuItem();
            mntBW = new javax.swing.JMenuItem();
            mnFilter = new javax.swing.JMenu();
            mntEdgeBlur = new javax.swing.JMenuItem();
            mntEdgeSharpen = new javax.swing.JMenuItem();
            mntEdge3 = new javax.swing.JMenuItem();
            mntEdgeGaussian = new javax.swing.JMenuItem();
            mntEdge5 = new javax.swing.JMenuItem();
            mntThreshold = new javax.swing.JMenuItem();
            mnAbout = new javax.swing.JMenu();
            mntAbout = new javax.swing.JMenuItem();
            mntHelp = new javax.swing.JMenuItem();
            mntPrint = new javax.swing.JCheckBoxMenuItem();
            
            getContentPane().setLayout(new java.awt.GridBagLayout());
            
            setTitle("Digit Classifier (Pattern Recognition)");
            setName("DCmain");
            setResizable(false);
            addWindowListener(new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent evt) {
                    exitForm(evt);
                }
            });
            
            pnlImageSelection.setBorder(new javax.swing.border.TitledBorder("Image Selection"));
            pnlImageSelection.setMaximumSize(new java.awt.Dimension(200, 280));
            pnlImageSelection.setMinimumSize(new java.awt.Dimension(200, 280));
            pnlImageSelection.setPreferredSize(new java.awt.Dimension(200, 280));
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 0;
            gridBagConstraints.gridwidth = 2;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.insets = new java.awt.Insets(1, 2, 1, 2);
            getContentPane().add(pnlImageSelection, gridBagConstraints);
            
            pnlImageDisplay.setBorder(new javax.swing.border.TitledBorder("Image Display"));
            pnlImageDisplay.setToolTipText("");
            pnlImageDisplay.setMaximumSize(new java.awt.Dimension(420, 280));
            pnlImageDisplay.setMinimumSize(new java.awt.Dimension(420, 280));
            pnlImageDisplay.setPreferredSize(new java.awt.Dimension(420, 280));
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 3;
            gridBagConstraints.gridy = 0;
            gridBagConstraints.gridwidth = 6;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.insets = new java.awt.Insets(1, 2, 1, 2);
            getContentPane().add(pnlImageDisplay, gridBagConstraints);
            
            lblImage = new JLabel("no image selected", JLabel.CENTER);
            
            srlpImage = new JScrollPane(lblImage);
            srlpImage.setMaximumSize(new java.awt.Dimension(410, 240));
            srlpImage.setMinimumSize(new java.awt.Dimension(410, 240));
            srlpImage.setPreferredSize(new java.awt.Dimension(410, 240));
            pnlImageDisplay.add(srlpImage);
            
            pnlButton.setLayout(new java.awt.GridBagLayout());
            
            pnlButton.setMaximumSize(new java.awt.Dimension(100, 280));
            pnlButton.setMinimumSize(new java.awt.Dimension(100, 280));
            pnlButton.setPreferredSize(new java.awt.Dimension(100, 280));
            
            
            btnDT.setMnemonic('D');
            btnDT.setText("Decision Tree");
            btnDT.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    btnDTActionPerformed(evt);
                }
            });
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 1;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.weighty = 1.0;
            gridBagConstraints.insets = new java.awt.Insets(1, 5, 1, 5);
            pnlButton.add(btnDT, gridBagConstraints);
            
            btnNN.setMnemonic('N');
            btnNN.setText("NearNeighbor");
            btnNN.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    btnNNActionPerformed(evt);
                }
            });
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 2;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.weighty = 1.0;
            gridBagConstraints.insets = new java.awt.Insets(1, 5, 1, 5);
            pnlButton.add(btnNN, gridBagConstraints);
            
            btnTrain.setMnemonic('T');
            btnTrain.setText("NN Training");
            btnTrain.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    btnTrainActionPerformed(evt);
                }
            });
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 3;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.weighty = 1.0;
            gridBagConstraints.insets = new java.awt.Insets(1, 5, 1, 5);
            pnlButton.add(btnTrain, gridBagConstraints);
            
            btnLoad.setMnemonic('L');
            btnLoad.setText("Load Image => ");
            btnLoad.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    btnLoadActionPerformed(evt);
                }
            });
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 4;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.weighty = 1.0;
            gridBagConstraints.insets = new java.awt.Insets(60, 5, 60, 5);
            pnlButton.add(btnLoad, gridBagConstraints);
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 2;
            gridBagConstraints.gridy = 0;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.insets = new java.awt.Insets(1, 2, 1, 2);
            getContentPane().add(pnlButton, gridBagConstraints);
            
            pnlFont.setLayout(new java.awt.GridBagLayout());
            
            pnlFont.setBorder(new javax.swing.border.TitledBorder("Font Option"));
            pnlFont.setMaximumSize(new java.awt.Dimension(120, 280));
            pnlFont.setMinimumSize(new java.awt.Dimension(120, 280));
            pnlFont.setPreferredSize(new java.awt.Dimension(120, 280));
            cbFontType.setMaximumSize(new java.awt.Dimension(100, 30));
            cbFontType.setMinimumSize(new java.awt.Dimension(100, 30));
            cbFontType.setPreferredSize(new java.awt.Dimension(100, 30));
            cbFontType.setRenderer(new MyFontRenderer());
            cbFontType.setSelectedIndex(2);
            cbFontType.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    cbFontTypeActionPerformed(evt);
                }
            });
            
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 1;
            gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
            pnlFont.add(cbFontType, gridBagConstraints);
            
            cbFontSize.setMaximumSize(new java.awt.Dimension(100, 30));
            cbFontSize.setMinimumSize(new java.awt.Dimension(100, 30));
            cbFontSize.setPreferredSize(new java.awt.Dimension(100, 30));
            cbFontSize.setSelectedIndex(2);
            cbFontSize.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    cbFontSizeActionPerformed(evt);
                }
            });
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 3;
            gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
            pnlFont.add(cbFontSize, gridBagConstraints);
            
            btnAdd.setMnemonic('A');
            btnAdd.setText("Add Testing");
            btnAdd.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    btnAddActionPerformed(evt);
                }
            });
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 4;
            gridBagConstraints.insets = new java.awt.Insets(35, 3, 3, 3);
            pnlFont.add(btnAdd, gridBagConstraints);
            
            lblFontType.setText(" Select Font Type");
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
            pnlFont.add(lblFontType, gridBagConstraints);
            
            lblFontSize.setText("Select Font Size");
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 2;
            gridBagConstraints.insets = new java.awt.Insets(20, 3, 3, 3);
            pnlFont.add(lblFontSize, gridBagConstraints);
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 3;
            gridBagConstraints.gridy = 1;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.insets = new java.awt.Insets(1, 2, 1, 2);
            getContentPane().add(pnlFont, gridBagConstraints);
            
            pnlTextInput.setBorder(new javax.swing.border.TitledBorder("Testing Digit Input"));
            pnlTextInput.setMaximumSize(new java.awt.Dimension(300, 280));
            pnlTextInput.setMinimumSize(new java.awt.Dimension(300, 280));
            pnlTextInput.setPreferredSize(new java.awt.Dimension(300, 280));
            txtaTextInput.setFont(new java.awt.Font("Dialog", 0, 36));
            //txtaTextInput.setLineWrap(true);
            txtaTextInput.setToolTipText("Input digit numbers here.");
            txtaTextInput.setMaximumSize(new java.awt.Dimension(260, 240));
            txtaTextInput.setMinimumSize(new java.awt.Dimension(260, 240));
            txtaTextInput.setPreferredSize(new java.awt.Dimension(260, 240));
            txtaTextInput.setCaretPosition(0);
            txtaTextInput.setMargin(new Insets(2,2,2,2));
            
            pnlTextInput.add(txtaTextInput);
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 1;
            gridBagConstraints.gridwidth = 3;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.insets = new java.awt.Insets(1, 2, 1, 2);
            getContentPane().add(pnlTextInput, gridBagConstraints);
            
            txtfResult.setText("Result");
            txtfResult.setToolTipText("Result Area");
            txtfResult.setBorder(null);
            //txtfResult.setMaximumSize(new java.awt.Dimension(260, 240));
            //txtfResult.setMinimumSize(new java.awt.Dimension(260, 240));
            //txtfResult.setPreferredSize(new java.awt.Dimension(260, 240));
            txtfResult.setEditable(false);
            txtfResult.setLineWrap(false);
            
            pnlResult = new JScrollPane(txtfResult, ScrollPaneConstants.
            VERTICAL_SCROLLBAR_AS_NEEDED,
            ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
            pnlResult.setBorder(new javax.swing.border.TitledBorder("Results Display"));
            pnlResult.setMaximumSize(new java.awt.Dimension(280, 280));
            pnlResult.setMinimumSize(new java.awt.Dimension(280, 280));
            pnlResult.setPreferredSize(new java.awt.Dimension(280, 280));
            
            //pnlResult.add(txtfResult);
            
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 4;
            gridBagConstraints.gridy = 1;
            gridBagConstraints.gridwidth = 5;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.weightx = 1.0;
            gridBagConstraints.insets = new java.awt.Insets(1, 2, 1, 2);
            getContentPane().add(pnlResult, gridBagConstraints);
            
            mnFile.setMnemonic('F');
            mnFile.setText("File");
            
            mnCreate.setMnemonic('C');
            mnCreate.setText("Random Creation");
            
            mntZeros.setText("Zeros");
            mntZeros.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntZerosActionPerformed(evt);
                }
            });
            mnCreate.add(mntZeros);
            
            mntOnes.setText("Ones");
            mntOnes.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntOnesActionPerformed(evt);
                }
            });
            mnCreate.add(mntOnes);
            
            mntTwos.setText("Twos");
            mntTwos.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntTwosActionPerformed(evt);
                }
            });
            mnCreate.add(mntTwos);
            
            mntThrees.setText("Threes");
            mntThrees.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntThreesActionPerformed(evt);
                }
            });
            mnCreate.add(mntThrees);
            
            mntFours.setText("Fours");
            mntFours.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntFoursActionPerformed(evt);
                }
            });
            mnCreate.add(mntFours);
            
            mntFives.setText("Fives");
            mntFives.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntFivesActionPerformed(evt);
                }
            });
            mnCreate.add(mntFives);
            
            mntSixs.setText("Sixs");
            mntSixs.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntSixsActionPerformed(evt);
                }
            });
            mnCreate.add(mntSixs);
            
            mntSevens.setText("Sevens");
            mntSevens.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntSevensActionPerformed(evt);
                }
            });
            mnCreate.add(mntSevens);
            
            mntEights.setText("Eights");
            mntEights.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntEightsActionPerformed(evt);
                }
            });
            mnCreate.add(mntEights);
            
            mntNines.setText("Nines");
            mntNines.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntNinesActionPerformed(evt);
                }
            });
            mnCreate.add(mntNines);
            
            mnFile.add(mnCreate);
            
            mntPrint.setMnemonic('P');
            mntPrint.setText("Feature Image Print");
            mntPrint.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntPrintActionPerformed(evt);
                }
            });
            
            mnFile.add(mntPrint);
            
            mntExit.setMnemonic('x');
            mntExit.setText("Exit");
            mntExit.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntExitActionPerformed(evt);
                }
            });
            
            mnFile.add(mntExit);
            
            mbrPR.add(mnFile);
            
            mnImage.setMnemonic('I');
            mnImage.setText("Image Option");
            mntBound.setMnemonic('B');
            mntBound.setText("Find Bound");
            mntBound.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntBoundActionPerformed(evt);
                }
            });
            
            mnImage.add(mntBound);
            
            mntFeature.setMnemonic('F');
            mntFeature.setText("Feature Extract");
            mntFeature.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntFeatureActionPerformed(evt);
                }
            });
            
            mnImage.add(mntFeature);
            
            mntBW.setText("Black and White");
            mntBW.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntBWActionPerformed(evt);
                }
            });
            
            mnImage.add(mntBW);
            
            
            mntEdgeBlur.setMnemonic('B');
            mntEdgeBlur.setText("Blur Edge");
            mntEdgeBlur.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntEdgeBlurActionPerformed(evt);
                }
            });
            mnFilter.add(mntEdgeBlur);
            
            mntEdgeSharpen.setMnemonic('S');
            mntEdgeSharpen.setText("Sharpen Edge");
            mntEdgeSharpen.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntEdgeSharpenActionPerformed(evt);
                }
            });
            mnFilter.add(mntEdgeSharpen);
            
            mntEdge3.setText("3x3 Edge");
            mntEdge3.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntEdge3ActionPerformed(evt);
                }
            });
            mnFilter.add(mntEdge3);
            
            mntEdgeGaussian.setText("Gaussian Blur");
            mntEdgeGaussian.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntEdgeGaussianActionPerformed(evt);
                }
            });
            mnFilter.add(mntEdgeGaussian);
            
            
            mntEdge5.setText("5x5 Edge");
            mntEdge5.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntEdge5ActionPerformed(evt);
                }
            });
            mnFilter.add(mntEdge5);
            
            
            mnFilter.setMnemonic('F');
            mnFilter.setText("Image Filters");
            mnImage.add(mnFilter);
            
            mntThreshold.setMnemonic('T');
            mntThreshold.setText("Gray Threshold");
            mntThreshold.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntThresholdActionPerformed(evt);
                }
            });
            
            mnImage.add(mntThreshold);
            
            mbrPR.add(mnImage);
            
            mnAbout.setMnemonic('A');
            mnAbout.setText("About");
            mntAbout.setMnemonic('A');
            mntAbout.setText("About Program");
            mntAbout.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntAboutActionPerformed(evt);
                }
            });
            
            mnAbout.add(mntAbout);
            
            mntHelp.setMnemonic('H');
            mntHelp.setText("Help");
            mntHelp.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    mntHelpActionPerformed(evt);
                }
            });
            
            mnAbout.add(mntHelp);
            
            mbrPR.add(mnAbout);
            
            setJMenuBar(mbrPR);
            
            pack();
        }
        
        private void cbFontSizeActionPerformed(java.awt.event.ActionEvent evt) {
            // set the font size in the textarea
            int new_size = Integer.parseInt(cbFontSize.getSelectedItem().toString());
            doc = (StyledDocument)txtaTextInput.getDocument();
            attr = new SimpleAttributeSet();
            StyleConstants.setFontSize(attr, new_size);
            txtaTextInput.setCharacterAttributes(attr, false);
        }
        
        private void cbFontTypeActionPerformed(java.awt.event.ActionEvent evt) {
            // set the font type in the textarea
            String new_font = ((Font)cbFontType.getSelectedItem()).getFamily();
            //txtaTextInput.setFont(new_font.deriveFont(txtaTextInput.getFont().getSize2D()));
            doc = (StyledDocument)txtaTextInput.getDocument();
            attr = new SimpleAttributeSet();
            StyleConstants.setFontFamily(attr, new_font);
            txtaTextInput.setCharacterAttributes(attr, false);
        }
        
        private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {
            System.out.println("add image to training set...");
            
            JFileChooser chooser = new JFileChooser();
            chooser.setCurrentDirectory(new File(System.getProperty("user.dir")));
            
            int result = chooser.showSaveDialog(null);
            
            if (result == JFileChooser.APPROVE_OPTION) {
                File f = chooser.getSelectedFile();
                if (!f.getName().endsWith(".jpg")) {
                    f = new File(f.getAbsolutePath().trim().concat(".jpg"));
                }
                saveImage(txtaTextInput, f);
            }
        }
        
        private void btnTrainActionPerformed(java.awt.event.ActionEvent evt) {
            System.out.println("nn training...");
            int digVal = -1;
            if (!extracted) {
                /*make the image black and white, but donot save the bw image*/
                greyImage();
                
                /* black and white image*/
                for (int rows = 0; rows < maxrows; rows++) {
                    for (int cols = 0; cols < maxcols; cols++) {
                        if (greyImage[rows][cols] < grey_threshold) {
                            greyImage[rows][cols] = 0; // set black
                        }
                        else {
                            greyImage[rows][cols] = 0xFFFFFF; // set white
                        }
                    }
                }
                
                extractor = new DigitExtraction(greyImage, print_fea);
                extractor.regionFinder(0, 0);
                extractor.regionExtration();
                extracted = true;
            }
            String[] numVal = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9"};
            String numRes = (String)JOptionPane.showInputDialog((Component)null,
            "Specify the digit:", "Digit Selection", JOptionPane.QUESTION_MESSAGE,
            null, numVal, numVal[0]);
            if (numRes != null){
                digVal = Integer.parseInt(numRes);
                if (digVal > -1 && digVal < 10) {
                    extractor.saveLib(digVal);
                }
                else {
                    System.out.println("Digit must be single!");
                }
            }
        }
        
        private void btnNNActionPerformed(java.awt.event.ActionEvent evt) {
            System.out.println("nearest neighbor classifiction...");
            if (!extracted) {
                /*make the image black and white, but donot save the bw image*/
                greyImage();
                
                /* black and white image*/
                for (int rows = 0; rows < maxrows; rows++) {
                    for (int cols = 0; cols < maxcols; cols++) {
                        if (greyImage[rows][cols] < grey_threshold) {
                            greyImage[rows][cols] = 0; // set black
                        }
                        else {
                            greyImage[rows][cols] = 0xFFFFFF; // set white
                        }
                    }
                }
                
                extractor = new DigitExtraction(greyImage, print_fea);
                extractor.regionFinder(0, 0);
                extractor.regionExtration();
                extracted = true;
            }
            /* display the result*/
            int[] result = extractor.NNclassify();
            int[] result2 = extractor.getGuessResult();
            String stres = "\n NN Result Print: \n";
            
            for (int i = 0; i < result.length; i++) {
                stres += "  " + result[i];
            }
            stres += "\n \n Possible NN Result Print: \n";
            for (int j = 0; j < result2.length; j++) {
                stres += "  " + result2[j];
            }
            stres += "\n \n Total Digit: " + result.length;
            setResultField(stres, 0);
        }
        
        private void btnDTActionPerformed(java.awt.event.ActionEvent evt) {
            System.out.println("decision tree classifiction...");
            
            if (!extracted) {
                /*make the image black and white, but donot save the bw image*/
                greyImage();
                
                /* black and white image*/
                for (int rows = 0; rows < maxrows; rows++) {
                    for (int cols = 0; cols < maxcols; cols++) {
                        if (greyImage[rows][cols] < grey_threshold) {
                            greyImage[rows][cols] = 0; // set black
                        }
                        else {
                            greyImage[rows][cols] = 0xFFFFFF; // set white
                        }
                    }
                }
                
                extractor = new DigitExtraction(greyImage, print_fea);
                extractor.regionFinder(0, 0);
                extractor.regionExtration();
                extracted = true;
            }
            /* display the result*/
            int[] result = extractor.DTclassify();
            int[] result2 = extractor.getGuessResult();
            String stres = "\n DT Result Print: \n";
            
            for (int i = 0; i < result.length; i++) {
                stres += "  " + result[i];
            }
            stres += "\n \n Possible DT Result Print: \n";
            for (int j = 0; j < result2.length; j++) {
                stres += "  " + result2[j];
            }
            stres += "\n \n Total Digit: " + result.length;
            setResultField(stres, 0);
        }
        
        private void btnLoadActionPerformed(java.awt.event.ActionEvent evt){
            System.out.println("display image...");
            if (pnlImageSelection.getCurrentSelectedFile() == null){
                JOptionPane.showMessageDialog((Component)null,
                "Not image file has been selected!\n Available files are listed at left.",
                "Image Load Error", JOptionPane.CLOSED_OPTION);
            }
            else {
                openImage();
            }
        }
        
        private void mntHelpActionPerformed(java.awt.event.ActionEvent evt) {
            JOptionPane.showMessageDialog((Component)null,
            "     Please contact me at:\n                          xiao@cs.queensu.ca",
            "Program Help", JOptionPane.CLOSED_OPTION);
        }
        
        private void mntExitActionPerformed(java.awt.event.ActionEvent evt) {
            System.exit(0);
        }
        
        private void mntPrintActionPerformed(java.awt.event.ActionEvent evt) {
            print_fea = mntPrint.getState();
        }
        
        private void mntEdgeBlurActionPerformed(java.awt.event.ActionEvent evt) {
            // Blur the image using the blur filter
            Kernel kernel = new Kernel(3, 3, data[0]);
            ConvolveOp convolve = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
            //BufferedImage scrImage = convolve.createCompatibleDestImage(workImage, ColorModel.getRGBdefault());
            BufferedImage scrImage = new BufferedImage(workImage.getWidth(), workImage.getHeight(),BufferedImage.TYPE_INT_RGB);
            convolve.filter(workImage, scrImage);
            workImage = scrImage;
            saveProcessedImage();
            
        }
        
        private void mntEdgeSharpenActionPerformed(java.awt.event.ActionEvent evt) {
            // Sharpen the image using the sharpen filter
            Kernel kernel = new Kernel(3, 3, data[1]);
            ConvolveOp convolve = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
            //BufferedImage scrImage = convolve.createCompatibleDestImage(workImage, ColorModel.getRGBdefault());
            BufferedImage scrImage = new BufferedImage(workImage.getWidth(), workImage.getHeight(),BufferedImage.TYPE_INT_RGB);
            convolve.filter(workImage, scrImage);
            workImage = scrImage;
            saveProcessedImage();
        }
        
        private void mntEdge3ActionPerformed(java.awt.event.ActionEvent evt) {
            // find the edge using the 3x3 edge filter
            Kernel kernel = new Kernel(3, 3, data[2]);
            ConvolveOp convolve = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
            //BufferedImage scrImage = convolve.createCompatibleDestImage(workImage, ColorModel.getRGBdefault());
            BufferedImage scrImage = new BufferedImage(workImage.getWidth(), workImage.getHeight(),BufferedImage.TYPE_INT_RGB);
            convolve.filter(workImage, scrImage);
            workImage = scrImage;
            saveProcessedImage();
        }
        
        private void mntEdgeGaussianActionPerformed(java.awt.event.ActionEvent evt) {
            // find the edge using the Gaussian filter
            Kernel kernel = new Kernel(3, 3, data[3]);
            ConvolveOp convolve = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
            //BufferedImage scrImage = convolve.createCompatibleDestImage(workImage, ColorModel.getRGBdefault());
            BufferedImage scrImage = new BufferedImage(workImage.getWidth(), workImage.getHeight(),BufferedImage.TYPE_INT_RGB);
            convolve.filter(workImage, scrImage);
            workImage = scrImage;
            saveProcessedImage();
        }
        
        private void mntEdge5ActionPerformed(java.awt.event.ActionEvent evt) {
            // find the edge using the 5x5 filter
            Kernel kernel = new Kernel(5, 5, data[4]);
            ConvolveOp convolve = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
            //BufferedImage scrImage = convolve.createCompatibleDestImage(workImage, ColorModel.getRGBdefault());
            BufferedImage scrImage = new BufferedImage(workImage.getWidth(), workImage.getHeight(),BufferedImage.TYPE_INT_RGB);
            convolve.filter(workImage, scrImage);
            workImage = scrImage;
            saveProcessedImage();
        }
        
        private void mntBoundActionPerformed(java.awt.event.ActionEvent evt) {
            // find the bound of the image
            greyImage();
            
            extractor = new DigitExtraction(greyImage, print_fea);
            extractor.regionFinder(0, 0);
            boundArray = extractor.getBoundBoxes();
            
            int[] bbox = new int[4];
            
            int min_x, max_x, min_y, max_y;
            int i, j;
            
            for (i = 0; i < boundArray.length/4; i ++) {
                min_x = boundArray[4*i+0];
                max_x = boundArray[4*i+1];
                min_y = boundArray[4*i+2];
                max_y = boundArray[4*i+3];
                for (j = min_x; j < max_x; j ++) {
                    testImage[j][min_y][RED] = 0xFF;
                    testImage[j+1][min_y][RED] = 0xFF;
                    testImage[j][min_y][BLUE] = 0x00;
                    testImage[j+1][min_y][BLUE] = 0x00;
                    testImage[j][min_y][GREEN] = 0x33;
                    testImage[j+1][min_y][GREEN] = 0x33;
                    
                    testImage[j][max_y][RED] = 0xFF;
                    testImage[j-1][max_y][RED] = 0xFF;
                    testImage[j][max_y][BLUE] = 0x00;
                    testImage[j-1][max_y][BLUE] = 0x00;
                    testImage[j][max_y][GREEN] = 0x33;
                    testImage[j-1][max_y][GREEN] = 0x33;
                }
                for (j = min_y; j < max_y; j ++) {
                    testImage[min_x][j][RED] = 0xFF;
                    testImage[min_x][j+1][RED] = 0xFF;
                    testImage[min_x][j][BLUE] = 0x33;
                    testImage[min_x][j+1][BLUE] = 0x33;
                    testImage[min_x][j][GREEN] = 0x00;
                    testImage[min_x][j+1][GREEN] = 0x00;
                    
                    testImage[max_x][j][RED] = 0xFF;
                    testImage[max_x][j-1][RED] = 0xFF;
                    testImage[max_x][j][BLUE] = 0x33;
                    testImage[max_x][j-1][BLUE] = 0x33;
                    testImage[max_x][j][GREEN] = 0x00;
                    testImage[max_x][j-1][GREEN] = 0x00;
                }
            }
            
            BufferedImage disImage = new BufferedImage(maxcols, maxrows,
            BufferedImage.TYPE_INT_RGB);
            for (int r = 0; r < maxrows; r++) {
                for (int c = 0; c < maxcols; c++) {
                    disImage.setRGB(c, r, testImage[r][c][RED]<<16 +
                    testImage[r][c][GREEN]<<8 +
                    testImage[r][c][BLUE]);
                }
            }
            
            disWindow = new JFrame();
            disImage.flush();
            JLabel lblImage = new JLabel(new ImageIcon(disImage), JLabel.CENTER);
            JButton btnDispose = new JButton("Close Window");
            
            Container windowContentPane = disWindow.getContentPane();
            windowContentPane.setLayout(new BoxLayout(windowContentPane, BoxLayout.Y_AXIS));
            windowContentPane.add(lblImage);
            windowContentPane.add(Box.createVerticalGlue());
            windowContentPane.add(btnDispose);
            
            btnDispose.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    disWindow.dispose();
                }
            });
            disWindow.setResizable(false);
            disWindow.setLocation(100, 100);
            disWindow.pack();
            disWindow.show();
            
        }
        
        /** feature extration item*/
        private void mntFeatureActionPerformed(java.awt.event.ActionEvent evt) {
            // feature extraction
            
            /*make the image black and white, but donot save the bw image*/
            greyImage();
            
            /* black and white image*/
            for (int rows = 0; rows < maxrows; rows++) {
                for (int cols = 0; cols < maxcols; cols++) {
                    if (greyImage[rows][cols] < grey_threshold) {
                        greyImage[rows][cols] = 0; // set black
                    }
                    else {
                        greyImage[rows][cols] = 0xFFFFFF; // set white
                    }
                }
            }
            
            extractor = new DigitExtraction(greyImage, print_fea);
            extractor.regionFinder(0, 0);
            extractor.regionExtration();
            /* save the result*/
            if (currentFile.getAbsolutePath().endsWith("jpg")) {
                extractor.saveFeatureText(currentFile.getAbsolutePath().replaceAll(".jpg", "_e.dat"));
            }
            else if (currentFile.getAbsolutePath().endsWith("gif")) {
                extractor.saveFeatureText(currentFile.getAbsolutePath().replaceAll(".gif", "_e.dat"));
            }
            else {
                extractor.saveFeatureText(currentFile.getAbsolutePath().concat(".dat"));
            }
            setResultField(extractor.toString(), 1);
            extracted = true; /* feature extraction has been done*/
        }
        
        private void mntThresholdActionPerformed(java.awt.event.ActionEvent evt) {
            System.out.println("change threshold...");
            // setting the threshold for black and white image
            thresholdDialog = new JDialog((Frame)null, "Black and White threshold: ", true);
            Container dialogContentPane = thresholdDialog.getContentPane();
            
            thresholdSlider = new JSlider(SwingConstants.HORIZONTAL, 0, 255, grey_threshold);
            thresholdSlider.putClientProperty("JSlider.isFilled", Boolean.TRUE);
            thresholdSlider.setPaintTicks(true);
            thresholdSlider.setPaintLabels(true);
            thresholdSlider.setMajorTickSpacing(127);
            thresholdSlider.setMinorTickSpacing(32);
            lblThreshold = new JLabel(Integer.toString(grey_threshold));
            thresholdOkDialog = new JButton("OK");
            thresholdCancelDialog = new JButton("Cancel");
            dialogContentPane.setLayout(new FlowLayout());
            dialogContentPane.add(thresholdSlider);
            dialogContentPane.add(lblThreshold);
            dialogContentPane.add(thresholdOkDialog);
            dialogContentPane.add(thresholdCancelDialog);
            
            thresholdSlider.addChangeListener(this);
            thresholdOkDialog.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    thresholdOKActionPerformed(evt);
                }
            });
            thresholdCancelDialog.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    thresholdCancelActionPerformed(evt);
                }
            });
            thresholdDialog.setBounds(100, 100, 270, 120);
            thresholdDialog.setResizable(false);
            thresholdDialog.show();
        }
        
        private void mntAboutActionPerformed(java.awt.event.ActionEvent evt) {
            JOptionPane.showMessageDialog((Component)null,
            "Digit Classifier CISC 859 Pattern Recognition\n Queen's University 2004.10 - Henry Xiao",
            "About Digit Classifier Program", JOptionPane.YES_OPTION);
        }
        
        private void mntBWActionPerformed(java.awt.event.ActionEvent evt) {
            
            pnlImageDisplay.removeAll();
            
            bwImage();
            
            lblImage = new JLabel(new ImageIcon(workImage), JLabel.CENTER);
            srlpImage = new JScrollPane(lblImage);
            srlpImage.setMaximumSize(new java.awt.Dimension(410, 240));
            srlpImage.setMinimumSize(new java.awt.Dimension(410, 240));
            srlpImage.setPreferredSize(new java.awt.Dimension(410, 240));
            pnlImageDisplay.add(srlpImage);
            pnlImageDisplay.revalidate();
            pnlImageDisplay.repaint();
        }
        
        private void thresholdOKActionPerformed(java.awt.event.ActionEvent evt) {
            grey_threshold = thresholdSlider.getValue();
            thresholdDialog.dispose();
            System.out.println("current threshold: " + grey_threshold);
        }
        
        private void thresholdCancelActionPerformed(java.awt.event.ActionEvent evt) {
            thresholdDialog.dispose();
            System.out.println("current threshold: " + grey_threshold);
        }
        
        private void mntZerosActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "0 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntOnesActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "1 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntTwosActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "2 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntThreesActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "3 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntFoursActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "4 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntFivesActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "5 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntSixsActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "6 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntSevensActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "7 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntEightsActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "8 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        private void mntNinesActionPerformed(java.awt.event.ActionEvent evt) {
            int[] randomset = randomGenerator(random_total);
            int i, j, num;
            
            try {
                doc = (StyledDocument)txtaTextInput.getDocument();
                doc.remove(0, doc.getLength()); /*clear out the text input area*/
                
                num = random_total/4;
                for (i = 0; i < 4; i ++) {
                    for (j = 0; j < num; j++) {
                        cbFontType.setSelectedIndex(randomset[i*num + j]);
                        //System.out.println(doc.getLength());
                        doc.insertString(doc.getLength(), "9 ", attr);
                    }
                    doc.insertString(doc.getLength(), "\n", attr);
                }
            }
            catch (Exception ex) {
                JOptionPane.showMessageDialog((Component)null,
                "Unable to generate the random set!",
                "Document Generating Problem", JOptionPane.CLOSED_OPTION);
            }
        }
        
        /** Exit the Application */
        private void exitForm(java.awt.event.WindowEvent evt) {
            System.exit(0);
        }
        
        /** Open and image in the pnlImageDisplay*
         */
        private void openImage() {
            
            extracted = false; /* set the feature extraction status to undo*/
            try {
                currentFile = pnlImageSelection.getCurrentSelectedFile();
                img = getToolkit().getImage(currentFile.getAbsolutePath());
                
                pnlImageDisplay.removeAll();
                
                lblImage = new JLabel(new ImageIcon(img), JLabel.CENTER);
                maxrows = img.getHeight(null);
                maxcols = img.getWidth(null);
                System.out.println("Image Size: " + maxcols + ", " + maxrows);
                
                srlpImage = new JScrollPane(lblImage);
                srlpImage.setMaximumSize(new java.awt.Dimension(410, 240));
                srlpImage.setMinimumSize(new java.awt.Dimension(410, 240));
                srlpImage.setPreferredSize(new java.awt.Dimension(410, 240));
                pnlImageDisplay.add(srlpImage);
                pnlImageDisplay.revalidate();
                pnlImageDisplay.repaint();
            }
            catch (Exception e) {
                e.printStackTrace();
                JOptionPane.showMessageDialog((Component)null,
                "Unable to save the image!",
                "Image Save Error", JOptionPane.CLOSED_OPTION);
            }
            System.gc();
            
            workImage = new BufferedImage(img.getWidth(null), img.getHeight(null),
            BufferedImage.TYPE_INT_RGB);
            Graphics2D g2 = workImage.createGraphics();
            g2.drawImage(img, null, null);
            g2.dispose();
            
            ImageOpEnable();
            setResultField("clear out", -1);
        }
        
        
        class MyFontRenderer extends BasicComboBoxRenderer {
            public Component getListCellRendererComponent(
            JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
                
                Font font = (Font)value;
                setFont( font.deriveFont(10.0f) );
                setText( font.getName() );
                
                return this;
            }
        }
        
        // ****************** Change Listener handler ********************
        
        public void stateChanged(ChangeEvent e) {
            if (e.getSource() == thresholdSlider) {
                lblThreshold.setText(String.valueOf(thresholdSlider.getValue()));
                repaint();
            }
        }
        
        static void saveImage(Component comp, File file) {
            try {
                BufferedImage image = new BufferedImage(comp.getWidth(), comp.getHeight(), BufferedImage.TYPE_INT_RGB);
                Graphics2D g = image.createGraphics();
                g.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS,RenderingHints.VALUE_FRACTIONALMETRICS_ON);
                g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
                comp.paint(g);
                g.dispose();
                ImageIO.write(image, "JPG", file);
                image.flush();
            }
            catch (IOException e) {
                e.printStackTrace();
                JOptionPane.showMessageDialog((Component)null,
                "Unable to save the image!",
                "Image Save Error", JOptionPane.CLOSED_OPTION);
            }
        }
        
        
        private void bwImage() {
            
            greyImage();
            
            for (int rows = 0; rows < maxrows; rows++) {
                for (int cols = 0; cols < maxcols; cols++) {
                    if (greyImage[rows][cols] < grey_threshold) {
                        greyImage[rows][cols] = 0; // set black
                    }
                    else {
                        greyImage[rows][cols] = 0xFFFFFF; // set white
                    }
                }
            }
        /*for (int i = 0; i < maxrows; i++) {
            for (int j = 0; j < maxcols; j++) {
                System.out.print(greyImage[i][j] + " ");
            }
            System.out.println();
        }*/
            
            //workImage = new BufferedImage(img.getWidth(null), img.getHeight(null),
            //        BufferedImage.TYPE_INT_RGB);
            //Graphics2D g2 = workImage.createGraphics();
            //g2.drawImage(img, null, null);
            //g2.dispose();
            
            for (int r = 0; r < maxrows; r++) {
                for (int c = 0; c < maxcols; c++) {
                    workImage.setRGB(c, r, greyImage[r][c]);
                }
            }
            saveProcessedImage();
        }
        
        private void greyImage() {
            //convert the original color image to grey image
            testImage = getImagePixels(img);
            
            for (int rows = 0; rows < maxrows; rows++) {
                for (int cols = 0; cols < maxcols; cols++) {
                    int avg = (testImage[rows][cols][RED]
                    + testImage[rows][cols][BLUE]
                    + testImage[rows][cols][GREEN]) / 3;
                    greyImage[rows][cols]=avg;
                }
            }
        }
        
        private int[][][] getImagePixels(Image img) {
            
            /**initial testImage, greyImage arrays*/
            int i, j;
            
            testImage = new int[maxrows][maxcols][4];
            greyImage = new int[maxrows][maxcols];
            
            // Get the raw pixel data
            iObserver observer = new iObserver();
            int width1 = img.getWidth(observer);
            int height1 = img.getHeight(observer);
            int[] rawPixels = utils.getPixels(img,width1,height1);
            
            // Each pixel is represented by 32 bits.  Separate the 32 bits into
            // four 8-bit values (red, green, blue, offset).
            int[][] rgbPixels = new int[rawPixels.length][4];
            for(j=0; j<rawPixels.length; j++) {
                rgbPixels[j][0] = ((rawPixels[j]>>16)&0xff);
                rgbPixels[j][1] = ((rawPixels[j]>>8)&0xff);
                rgbPixels[j][2] = (rawPixels[j]&0xff);
                rgbPixels[j][3] =((rawPixels[j]>>24)&0xff);
            }  // for j
            
            // Arrange the data by rows and columns
            int[][][] imagePixels = new int[height1][width1][4];
            int index=0;
            for(int row=0; row<imagePixels.length; row++) {
                for(int col=0; col<imagePixels[0].length; col++) {
                    for(int rgbo=0; rgbo<4; rgbo++) {
                        imagePixels[row][col][rgbo]=rgbPixels[index][rgbo];
                    } // for rgbo
                    index++;
                } // for col
            }  // for row
            return imagePixels;
        } // end of method getImagePixels
        
        
        public void saveProcessedImage(){
            try {
                Graphics2D g = workImage.createGraphics();
                File f = null;
                g.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS,RenderingHints.VALUE_FRACTIONALMETRICS_ON);
                g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
                
                g.dispose();
                JFileChooser chooser = new JFileChooser();
                chooser.setCurrentDirectory(new File(System.getProperty("user.dir")));
                
                int result = chooser.showSaveDialog(null);
                
                if (result == JFileChooser.APPROVE_OPTION) {
                    File tf = chooser.getSelectedFile();
                    if (!tf.getAbsolutePath().endsWith(".jpg")) {
                        f = new File(tf.getAbsolutePath().trim().concat(".jpg"));
                    }
                    else {
                        f = chooser.getSelectedFile();
                    }
                    
                    ImageIO.write(workImage, "JPG", f);
                    workImage.flush();
                }
                currentFile = f;
                pnlImageSelection.addFile(currentFile);
                pnlImageSelection.tableChanged();
                
                img = getToolkit().getImage(currentFile.getAbsolutePath());
                
                pnlImageDisplay.removeAll();
                
                lblImage = new JLabel(new ImageIcon(img), JLabel.CENTER);
                maxrows = img.getHeight(null);
                maxcols = img.getWidth(null);
                
                srlpImage = new JScrollPane(lblImage);
                srlpImage.setMaximumSize(new java.awt.Dimension(410, 240));
                srlpImage.setMinimumSize(new java.awt.Dimension(410, 240));
                srlpImage.setPreferredSize(new java.awt.Dimension(410, 240));
                pnlImageDisplay.add(srlpImage);
                pnlImageDisplay.revalidate();
                pnlImageDisplay.repaint();
                
                System.gc();
            }
            catch (IOException e) {
                e.printStackTrace();
                JOptionPane.showMessageDialog((Component)null,
                "Unable to save the image!",
                "Image Save Error", JOptionPane.CLOSED_OPTION);
            }
            
        }  // end of method saveImage
        
        private int[] randomGenerator(int n) {
            int[] randomNum = new int[n];
            java.util.List fontList = new ArrayList(fonts.length);
            int i;
            //System.out.print("Random set: ");
            
            for (i = 0; i < fonts.length; i ++)
                fontList.add(new Integer(i));
            
            Collections.shuffle(fontList);
            Object[] array = fontList.toArray();
            for (i = 0; i < n; i++) {
                randomNum[i] = ((Integer)array[i]).intValue();
                //System.out.print(randomNum[i] + " ");
            }
            //System.out.println();
            
            return randomNum;
        }
        
        private void ImageOpEnable() {
            mntBW.setEnabled(true);
            mntBound.setEnabled(true);
            mntFeature.setEnabled(true);
            mntEdgeBlur.setEnabled(true);
            mntEdgeSharpen.setEnabled(true);
            mntEdge3.setEnabled(true);
            mntEdgeGaussian.setEnabled(true);
            mntEdge5.setEnabled(true);
        }
        
        private void ImageOpDisable() {
            mntBW.setEnabled(false);
            mntBound.setEnabled(false);
            mntFeature.setEnabled(false);
            mntEdgeBlur.setEnabled(false);
            mntEdgeSharpen.setEnabled(false);
            mntEdge3.setEnabled(false);
            mntEdgeGaussian.setEnabled(false);
            mntEdge5.setEnabled(false);
        }
        
        /** Print the result to the result display panel
         * t = 0 for display classification result
         *   = 1 for display extraction result
         *   = 2 for display training result
         *   else for clear the field
         */
        private void setResultField(String s, int t) {
            if (t == 0) {
                txtfResult.setText("     ********************* \n" +
                "      Classifiction Result \n" +
                "     ********************* \n \n" + s);
            }
            else if (t == 1) {
                txtfResult.setText("     ********************* \n" +
                "      Extraction Result \n" +
                "     ********************* \n \n" + s);
            }
            else if (t == 2) {
                txtfResult.setText("     ********************* \n" +
                "      Training Result \n" +
                "     ********************* \n \n" + s);
            }
            else {
                txtfResult.setText("");
            }
        }
        
        /**
         * @param args the command line arguments
         */
        public static void main(String args[]) {
            DigitPR myDigitPR = new DigitPR();
            Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
            
            myDigitPR.setLocation(d.width/2 - 400, d.height/2 - 320);
            myDigitPR.setSize(800, 650);
            myDigitPR.show();
            
        }
        
        // Variables declaration - Components
        private javax.swing.JButton btnLoad;
        private javax.swing.JButton btnAdd;
        private javax.swing.JButton btnDT;
        private javax.swing.JButton btnNN;
        private javax.swing.JButton btnTrain;
        private javax.swing.JComboBox cbFontSize;
        private javax.swing.JComboBox cbFontType;
        private javax.swing.JLabel lblFontSize;
        private javax.swing.JLabel lblFontType;
        private javax.swing.JMenuBar mbrPR;
        private javax.swing.JMenu mnAbout;
        private javax.swing.JMenu mnFile;
        private javax.swing.JMenu mnFilter;
        private javax.swing.JMenu mnImage;
        private javax.swing.JMenu mnCreate;
        private javax.swing.JMenuItem mntFont;
        private javax.swing.JMenuItem mntZeros;
        private javax.swing.JMenuItem mntOnes;
        private javax.swing.JMenuItem mntTwos;
        private javax.swing.JMenuItem mntThrees;
        private javax.swing.JMenuItem mntFours;
        private javax.swing.JMenuItem mntFives;
        private javax.swing.JMenuItem mntSixs;
        private javax.swing.JMenuItem mntSevens;
        private javax.swing.JMenuItem mntEights;
        private javax.swing.JMenuItem mntNines;
        private javax.swing.JMenuItem mntAbout;
        private javax.swing.JMenuItem mntBW;
        private javax.swing.JMenuItem mntBound;
        private javax.swing.JMenuItem mntFeature;
        private javax.swing.JMenuItem mntEdgeBlur;
        private javax.swing.JMenuItem mntEdgeSharpen;
        private javax.swing.JMenuItem mntEdge3;
        private javax.swing.JMenuItem mntEdgeGaussian;
        private javax.swing.JMenuItem mntEdge5;
        private javax.swing.JMenuItem mntExit;
        private javax.swing.JMenuItem mntHelp;
        private javax.swing.JMenuItem mntThreshold;
        private javax.swing.JCheckBoxMenuItem mntPrint;
        private javax.swing.JPanel pnlButton;
        private javax.swing.JPanel pnlFont;
        private javax.swing.JPanel pnlImageDisplay;
        private javax.swing.JScrollPane srlpImage;
        private FileDisplayPanel pnlImageSelection;
        private javax.swing.JScrollPane pnlResult;
        private javax.swing.JPanel pnlTextInput;
        private javax.swing.JTextPane txtaTextInput;
        private javax.swing.JTextArea txtfResult;
        private javax.swing.JLabel lblImage;
        
        private JDialog thresholdDialog;
        private JSlider thresholdSlider;
        private JLabel lblThreshold;
        private JButton thresholdOkDialog;
        private JButton thresholdCancelDialog;
        // End of variables declaration
        
}
